my $dbhost = $main::pluginconfig{'setclidontransfer'}{'database_host'}{''};
my $dbname = $main::pluginconfig{'setclidontransfer'}{'database_name'}{''};
my $dbuser = $main::pluginconfig{'setclidontransfer'}{'database_user'}{''};
my $dbpass = $main::pluginconfig{'setclidontransfer'}{'database_password'}{''};

my $db_connected = 0;
my $dbhsetclid;

sub setclid_connect_db {
    $dbhsetclid = new AnyEvent::DBI "DBI:mysql:$dbname;host=$dbhost", $dbuser, $dbpass,
    on_connect => sub {
        my $dbb = shift;
        my $success = shift;
        if ($success == 1) {
            $db_connected = 1;
        }
    },
    on_error => sub {
       if ( $@ =~ m/gone away/ ) {
           $db_connected = 0;
       }
       print "error $@ at $_[1]:$_[2]\n";
    };
}

sub setclid_send_command_to_manager {
    my ( $asterisk, $comando, $extra ) = @_;
    if ( !defined($extra) ) { $extra = ''; }
    if ( !defined($asterisk) ) { return; }

    my $action_id = $asterisk->send_action(
        $comando,
        sub {
            my ( $asterisk, $response ) = @_;
            \&setclid_handle_ami_response( $asterisk, $response, $extra );
        },
        3
    );
    return $action_id;
}

sub setclid_handle_ami_response {
    my ( $asterisk, $response, $extra ) = @_;
    my ($cmd,$channel,$destinationnumber,$clid) = split(/!/,$extra);
    if ($cmd eq 'setCIDTransfer') {
        foreach my $manager_host ( keys %main::managers ) {
            setclid_send_command_to_manager( $main::astman{$manager_host}, {
                 Action => 'UserEvent',
                 UserEvent => 'TRANSFERstart',
                 Channel => $channel,
                 Family => 'TRANSFERstart',
                 Value => $destinationnumber
            }, "TransferSent!$channel!$clid!$destinationnumber" );
        }
    } 
}

setclid_connect_db();

$Client_Pre_Command_Handler{'setclidontransfer'}{'setclidontransfer'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return;

    my ($channel,$clid) = split(/~/,$destino);
    my $query =  "SELECT cidnum FROM callerid_entries WHERE '$clid' LIKE CONCAT(prefix,'%') LIMIT 1";

    print "$query\n";
    $dbhsetclid->exec($query,(), sub {
        my $db     = shift;
        my $active = shift;
        my $rv     = shift;

        foreach my $camp (@$active) {
            my $cidnum       = @$camp[0];

            foreach my $manager_host ( keys %main::managers ) {
            setclid_send_command_to_manager( $main::astman{$manager_host}, {
                 Action => 'SetVar',
                 Channel => $channel,
                 Variable => 'CALLERID(number)',
                 Value => $cidnum
            }, "setCIDTransfer!$channel!$clid!$cidnum" );
            }
         }
   });

    return @allreturn;
};

$AMI_Event_Handler{'setclidontransfer'}{'LINK'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;

    my $channel1 = ${$event}{Channel1};
    my $channel2 = ${$event}{Channel2};

    $return  = "Action: UserEvent\r\n";
    $return .= "UserEvent: LINKChannel\r\n";
    $return .= "Channel: $channel1\r\n";
    $return .= "Family: LINKChannel\r\n";
    $return .= "Value: $channel1\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    $return  = "Action: UserEvent\r\n";
    $return .= "UserEvent: LINKChannel\r\n";
    $return .= "Channel: $channel2\r\n";
    $return .= "Family: LINKChannel\r\n";
    $return .= "Value: $channel2\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

 
    return @allreturn;
};
